<template>
  <div>
    <v-card
      v-if="card"
      v-bind="$attrs"
      :class="levelStylings[level].cardClasses"
      flat
    >
      <v-card-title
        v-if="i18n || title || hasSlot('card-title')"
        :class="levelStylings[level].titleClasses"
      >
        <span v-if="i18n || title">
          {{ titleText }}
        </span>
        <slot name="card-title" />
        <GIconBtn
          v-if="wikiEntry"
          i18n="form.showInformation"
          icon="mdi-information"
          :btn-class="levelStylings[level].btnClasses"
          small-btn
          @click="toggleInformation"
        />
        <slot name="card-title-append" />
        <v-spacer v-if="!hasSlot('card-title-append')" />
        <GIconBtn
          v-if="optional"
          i18n="form.delete"
          icon="delete"
          :btn-class="levelStylings[level].btnClasses"
          small-btn
          @click="$emit('deleteElement')"
        />
        <GIconBtn
          v-if="addBtnHint"
          :i18n="addBtnHint"
          icon="add"
          :btn-class="levelStylings[level].btnClasses"
          small-btn
          @click="$emit('addElement')"
        />
      </v-card-title>
      <v-card-text :class="{ 'border-primary': border, 'pa-0': noPadding }">
        <slot />
      </v-card-text>
    </v-card>
    <slot v-else />
  </div>
</template>

<script>
import { generateWikiUri } from "assets/util/general";
import GIconBtn from "@/components/App/Common/GIconBtn";
export default {
  name: "GI18nCard",
  components: { GIconBtn },
  props: {
    card: {
      type: Boolean,
      default: true,
    },
    noPadding: {
      type: Boolean,
      default: false,
    },
    i18n: String,
    addBtnHint: String,
    title: String,
    optional: Boolean,
    extensible: Boolean,
    level: {
      type: String,
      validator(val) {
        return ["first", "second", "third", "none"].includes(val);
      },
      default: () => "first",
    },
    border: {
      type: Boolean,
      default: true,
    },
    wikiEntry: String,
  },
  computed: {
    titleText() {
      return this.i18n ? this.$t(this.i18n) : this.title;
    },
    levelStylings() {
      return {
        first: {
          cardClasses: "",
          titleClasses: "pl-4 pr-1 py-1 text-subtitle-1 primary white--text",
          btnClasses: "theme--dark",
        },
        second: {
          cardClasses: "",
          titleClasses: "pl-4 pr-1 py-1 subtitle-2 level-second white--text",
          btnClasses: "theme--dark",
        },
        third: {
          cardClasses: "",
          titleClasses: "pl-4 pr-1 py-1 subtitle-2 grey lighten-2",
          btnClasses: "theme--light",
        },
        none: {
          cardClasses: "",
          titleClasses: "subtitle-1",
          btnClasses: "theme--light",
        },
      };
    },
  },
  methods: {
    hasSlot(name = "default") {
      return !!this.$slots[name] || !!this.$scopedSlots[name];
    },
    toggleInformation() {
      if (this.wikiEntry) {
        window.open(generateWikiUri(this.wikiEntry), "_blank").focus();
      }
    },
  },
};
</script>

<style>
.level-second {
  background-color: #0d7bc6;
}

.border-primary {
  border: 1px solid lightgrey;
}
</style>
